const $ = require('jquery');
require("@less/dept/keyItemFlawControlDept.less");
require('../modal.js');
const {api} = require('../api.js')
const {post,getCookie,getUrlArgObjectNew,emptyBox,setTitleTxt,setDatePicker,getPickerDate,expJson,downloadExportedData,initScroll,listenScroll} = require('../utils.js')
require('../../resource/jquery-ui/jquery-ui.min.js');
require('../../resource/jquery-ui/jquery-ui.min.css');
const iconCheck= require("@images/icon_check.png")
const iconUnCheck = require("@images/icon_unchecked.png")
const iconDown= require("@images/arrow_down.png")
const iconUp = require("@images/arrow_up.png")
const loadingImg = require("@images/loading.gif")
const arrowLeft= require("@images/arrow_left.png")
const arrowRight = require("@images/arrow_right.png")
let  deptName = "", behospitalCode="", deptNameTemp = "",deptId='',deptIdTemp='', behospitalCodeTemp="", data_desc="",data_asc="",casesName="",casesNameTemp="";
let srcUrl = $("#contentIframe",parent.document).attr("src")
statisticsType = getUrlArgObjectNew("dateType",srcUrl)||"";
from = getUrlArgObjectNew("from",srcUrl)||""
lineType = getUrlArgObjectNew("lineType",srcUrl)||""
let startDateParam = getUrlArgObjectNew("startDateParam",srcUrl)||""
let endDateParam = getUrlArgObjectNew("endDateParam",srcUrl)||""
$(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
/*if(lineType){
  $("th[code="+data_desc+"]").addClass("desc");
}*/
//setTitleTxt('',from)         //导航栏面包屑
listenScroll()
let isPlacefile = getCookie('isPlacefile')||1
let deptList = JSON.parse(localStorage.getItem('deptList')) || []

if(statisticsType == 1){
  setDatePicker($("#datepicker"),$("#datepicker2"),1)
}else if(statisticsType == 2){
  setDatePicker($("#datepicker"),$("#datepicker2"),2)
}else if(statisticsType == 3){
  setDatePicker($("#datepicker"),$("#datepicker2"),3,new Date(startDateParam),new Date(endDateParam))
}else{
  setDatePicker($("#datepicker"),$("#datepicker2"),'default')
}
if(!statisticsType){
  setDatePicker($("#datepicker"),$("#datepicker2"),'default')
}
$(".abnormalClear").click(function(){
  data_desc="";
  data_asc="";
  deptId="";
  deptIdTemp="";
  deptName=deptNameTemp="";
  casesName=casesNameTemp=""
  setDatePicker($("#datepicker"),$("#datepicker2"),"default")
  deptName =deptNameTemp= deptList[0]&&deptList[0].deptName
  $(".selectDept").attr({'title':deptName,'data-id':''}).html(deptName).append(`<img class="arrow" src=${iconDown} alt="下拉">`)
  $(".selectModuleType").val('全部')
  $("th[code]").removeClass("asc desc")
    getmoduleTypeList()
    //behospitalCode =behospitalCodeTemp= ""
  getTabData(1)
})
$(".partTitle a").click(function(){
  //初始菜单选中
  $(".menu .page",parent.document).removeClass("active").eq(0).addClass("active");
  $(".container",parent.document).addClass("console-cont");
})

// YH-ZKK-GJTMQXZB
$(".menu .page", parent.document).removeClass("active")
$(parent.document).find(".menu .page[code=YH-KSZR-GJTMQXZB_XQ]").addClass("active")

//判断有无某一权限
/*function hasData(data){
  let trdObj = JSON.parse(getCookie("trdObj"))
  let lis = trdObj['YH-BLZK-ZKPF']
  if(!lis){
    return false
  }
  if(lis.indexOf(data)>-1){//有权限
    return true
  }
  return false;
}*/
function getTabData(activePage){
  const dateStatrt = getPickerDate($("#datepicker"),1)
  const dateEnd = getPickerDate($("#datepicker2"),2)
  const start = new Date(dateStatrt).getTime()
  const end = new Date(dateEnd).getTime()
  if(start > end){
    $.alerModal({"message":'开始时间不能大于结束时间~',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
    return
  }
  const param = {
    current: 1,
    size: 15,
    "deptName": deptName=="全部"?"":deptName||"",
    // "name": casesName=="全部"?"":casesName||"",
    "doctorName": casesName=="全部"?"":casesName||"",
    "asc":data_asc,     //升序
    "desc":data_desc,       //降序
    //"type": 0, //1-本月，2-本年,0-自定义时间（现在所有都是自定义时间，都会传开始日期和结束日期）
    "startDate":dateStatrt.replace(/\//g,'-'),
    "endDate":dateEnd.replace(/\//g,'-')
  }
  startDateParam = dateStatrt
  endDateParam = dateEnd
  $('.pagination').html("")
  $('.key-list tbody').html(emptyBox('努力加载中...','',1))
  post(api.entryStatisticsByDept,param).then(res =>{
    if(res.data.code == '0'){
      const data = res.data.data||[];
      renderTab(data,data.hospitalId,activePage);
      renderPagination(totalPage,Number(activePage),totalNum)
      if(totalPage > 1){
        renderPagination(totalPage,Number(activePage),totalNum)
      } else{
        $('.pagination').html("")
      }
    }else{
      $.alerModal({"message":res.data.msg,type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
    }
  }).catch((e) =>{

  })
}


$(".filter").on("click", function(e){
  deptName = deptNameTemp;
  behospitalCode = behospitalCodeTemp;
  casesName=casesNameTemp
  if(deptName == ""){
      $(".selectDept").attr({'title':"全部",'data-id':''}).val("全部")
  }
  getTabData(1)
})
function renderTab(data,hisId,activePage){
  let str = ``
  for(let i = 0; i < data.length; i++){
    const item = data[i]
    str += `
          <tr  data-index=${i} class="dataGet" data-doc="${item.doctorName}">
              <td  class="textCenter">${(activePage-1)*15 + i+1}</td>
              <td >${item.doctorName || "-"}</td>
              <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.consultationEntryId || ""}" data-name="${item.consultationEntryName || ""}">${item.consultationNum+'' || "-"}</td>
              <td >${item.consultationPercentStr || "-"}</td>
              <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.operationNameEntryId || ""}" data-name="${item.operationNameEntryName || ""}">${item.operationNameNum+'' || "-"}</td>
              <td >${item.operationNamePercentStr+'' || "-"}</td>
              <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.operation15MinuteEntryId || ""}" data-name="${item.operation15MinuteEntryName || ""}">${item.operation15MinuteNum+'' || "-"}</td>
              <td >${item.operation15MinutePercentStr+'' || "-"}</td>
              <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.operationTimeEntryId || ""}" data-name="${item.operationTimeEntryName || ""}">${item.operationTimeNum+'' || "-"}</td>
              <td >${item.operationTimePercentStr+'' || "-"}</td>
              <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.crisisEntryId || ""}" data-name="${item.crisisEntryName || ""}">${item.crisisNum+'' || "-"}</td>
              <td >${item.crisisPercentStr+'' || "-"}</td>
              <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-fromDays="1">${item.beHosGT31DaysMRNum + '' || "-"}</td>
              <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.stageSummaryEntryId || ""}" data-name="${item.stageSummaryEntryName || ""}">${item.stageSummaryNum+'' || "-"}</td>
              <td >${item.stageSummaryPercentStr+'' || "-"}</td>
          </tr>
      `
  }
  $('.key-list tbody').html(str?str:emptyBox())
  /*bindScoreDetail(hisId)*/
  $(".goHomeDetail").click(function(){
    let caseName = $(this).attr("data-name");
    let casesId = $(this).attr("data-id");
    let name=$(this).attr("dept-name");
    let docName=$(this).parent(".dataGet").attr("data-doc");
    name=name==="全院"?"全部":name;
    let id=$(this).attr("dept-id");
    // 确定31天处跳转
    let fromDays = $(this).attr("data-fromDays");
    $(parent.document).find("#contentIframe").attr("src", "qcListCopyDept.html?from=3&deptName=" + deptName + "&deptId=" + deptName + "&casesEntryId=" + casesId + "&defectName=" + caseName + "&startDate=" + startDateParam + "&endDate=" + endDateParam + "&fromDays=" + fromDays+"&docName="+docName)
  })
  // initScroll("partDetailControl","YX",1)
}
//科室相关
bindDeptSelect()
function bindDeptSelect(){
    $(document).on("click",'.deptItem',function(){
        const deptItemName = $(this).attr("data-name")||''
        const deptItemId = $(this).attr("data-id")
        deptName =deptNameTemp=deptItemName
        if(deptItemName.length > 10){
            $('.selectDept').html(deptItemName.substring(0,8)+'...')
        }else{
            $('.selectDept').html(deptItemName)
        }
        $('.selectDept ').attr({'title':deptItemName,'data-id':deptItemName})
        $(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)

        getmoduleTypeList('',deptItemName)
        $(".deptList").css("display", "none")
    })
}
$('.selectDept').on("click", function(e){
  e.stopPropagation()
  $(".levelList ").css("display","none")
  $(".selectLevel .arrow").attr("src",iconDown)
  const showList =  $(".deptList ").css("display")
  if(showList == "none" ||!showList){
      $(".deptList ").css("display","block")
      $(".selectDept .arrow").attr("src",iconUp)
  }else{
      $(".deptList ").css("display", "none")
      $(".selectDept .arrow").attr("src",iconDown)
  }
})
getDeptList()
function getDeptList(){
  let str = ``
  getTabData(1)
  if(deptList.length<=0)return
  deptName = deptNameTemp = deptList[0].deptName
  $(".selectDept").attr("data-id",deptName).find("i").html(deptName)
  for(let i = 0;i < deptList.length;i++){
      let tmp = deptList[i]
      str += `<li class="deptItem ellipsis" title="${tmp.deptName}" data-id="${tmp.deptName}" data-name="${tmp.deptName}">${tmp.deptName}</li>`
  }
  getmoduleTypeList('',deptName)
  $(".filterDropList").html(str)
}

//模块类型
$('.selectModuleType').on("focus", function(e){
  e.stopPropagation()
  $(".rejectList ").css("display","none")
  $(".usedList ").css("display", "none")
  $(".selectReject .arrow").attr("src",iconDown)
  $(".selectUsed .arrow").attr("src",iconDown)
  $(".moduleTypeList ").css("display","block")
})
$('.selectModuleType').on("blur", function(e){
  $(".moduleTypeList ").css("display","none")
})
$('.selectModuleType').on("input", function(e){
  let val = $(this).val().trim()
  casesName = casesNameTemp = val
  getmoduleTypeList(val)
})
//获取模块类型
function getmoduleTypeList(val,dept){
  post(api.getListDoctor,{inputStr:val=="全部"?"":val||"",deptName:dept||deptName}).then(res =>{
      if(res.data.code == '0'){
         const moduleTypeList = res.data.data
         renderModuleTypeList(moduleTypeList)
      }else{
          renderModuleTypeList([])
      }
  }).catch((e) =>{
  
  })
}
function renderModuleTypeList(moduleTypeList){
  if(moduleTypeList.length == 0){
    $('.moduleTypeList').html("")
    return
  }
  let str = `<li class="modeTypeItem " data-id=" " data-name="全部">全部</li>`
  for(let i = 0; i < moduleTypeList.length; i++){
      str += `<li class="modeTypeItem ellipsis" title=${moduleTypeList[i].name} data-id=${moduleTypeList[i].doctorId} data-name=${moduleTypeList[i].name}> ${moduleTypeList[i].name}</li>`
  }
  $('.moduleTypeList').html(str)
  bindModuleTypeSelect()
}

//模块类型选择
function bindModuleTypeSelect(){
  $('.modeTypeItem').on("mousedown",function(){
      const modeTypeItemName = $(this).attr("data-name")
      const modeTypeItemId = $(this).attr("data-id")
      casesIdTemp =modeTypeItemId
      casesName=casesNameTemp = modeTypeItemName=="全部"?"":modeTypeItemName;
      $('.selectModuleType').val(modeTypeItemName).attr("title",modeTypeItemName)
      $(".moduleTypeList ").css("display", "none")
  })
}

function loading(){
  const str = `
    <div class="loadingBox">
            <div class="mask"></div>
            <img class="loadingImg" src=${loadingImg}  alt="loading" />
        </div>
    `
  $("#mainBox", parent.document).append(str)
}
function hideLoading(){
  $("#mainBox .loadingBox", parent.document).remove()
}
$(document).on("click", function(){
  $(".deptList").css("display", "none");
  $(".selectDept .arrow").attr("src",iconDown)
})
$("th[code]").on("click",function(e){
  const code=$(this).attr("code");
  if(data_asc==code){
    data_desc=code;
    data_asc="";
    $("th[code]").removeClass("asc desc");
    $(this).addClass("desc");
  }else{
    data_desc="";
    data_asc=code;
    $("th[code]").removeClass("asc desc");
    $(this).addClass("asc");
  }
  getTabData(1);
});


//分页渲染
function renderPagination(totalPage,activePage,totalNum){
  let str = `<span class="totalSum">共${totalPage}页/${totalNum}条数据</span><span class="prePage"><img class="arrowPage" src=${arrowLeft} /></span>`
  if(totalPage <= 6){
    for(let i = 1; i <= totalPage; i++){

      str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
    }
  }else{
    if(activePage <= 3){ //选中页数小于4
      for(let i = 1; i <= 4; i++){
        str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
      }
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`

    } else if(activePage > totalPage -3){
      str += `<span class="pageNum page1" data-page=1>1</span>`
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+(totalPage-3)}" data-page=${totalPage -3}>${totalPage -3}</span>`
      str += `<span class="pageNum ${'page'+(totalPage-2)}" data-page=${totalPage -2}>${totalPage -2}</span>`
      str += `<span class="pageNum ${'page'+(totalPage-1)}" data-page=${totalPage -1}>${totalPage -1}</span>`
      str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
    } else {
      str += `<span class="pageNum page1" data-page=1>1</span>`
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+(activePage -1)}" data-page=${activePage -1}>${activePage -1}</span>`
      str += `<span class="pageNum ${'page'+activePage}" data-page=${activePage}>${activePage}</span>`
      str += `<span class="pageNum ${'page'+(activePage +1)}" data-page=${activePage +1}>${activePage +1}</span>`
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
    }

  }
  str += `<span class="nextPage"><img class="arrowPage" src=${arrowRight} /></span>`
  $('.pagination').html(str)
  $('.page' + activePage).addClass('activePage')
  $(".pageNum").on("click", function(e){
    const activePageNow = Number($(this).attr('data-page'))
    getTabData(activePageNow)
    // renderPagination(totalPage,activePageNow,totalNum)
  })
  $(".prePage").on("click", function(e){
    let activePageNow = Number($(".activePage").attr('data-page'))
    if(activePageNow > 1){
      activePageNow--
      getTabData(activePageNow)
      // renderPagination(totalPage,activePageNow,totalNum)
    }
  })
  $(".nextPage").on("click", function(e){
    let activePageNow = Number($(".activePage").attr('data-page'))
    if(activePageNow < totalPage){
      activePageNow++
      getTabData(activePageNow)
      // renderPagination(totalPage,activePageNow,totalNum)
    }
  })

}

$(function() {
  const  iconCalenBlue= require("@images/icon_calen_blue.png")
  const  iconCalenGrey= require("@images/icon_calen_grey.png")
  $('.datapickerBox').append(`<img class="iconCalen" src=${iconCalenGrey} />`)
  $('.iconCalen').on("mouseenter", function(e){
    $(this).attr("src", iconCalenBlue)
  })
  $('.iconCalen').on("mouseleave", function(e){
    $(this).attr("src", iconCalenGrey)
  })
  $('.iconCalen').on("click", function(e){
    $(this).parent().find("input").focus()
  })
  $('.exportData').click(function(){
      const start = new Date(startDateParam).getTime()
      const end = new Date(endDateParam).getTime()
      if(start > end){
          $.alerModal({"message":'开始时间不能大于结束时间~',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
          return
      }
      const param = {
        "isPlacefile":isPlacefile,
        "deptName": deptName=="全部"?"":deptName||"",
        // "name": casesName=="全部"?"":casesName||"",
        "doctorName": casesName=="全部"?"":casesName||"",
        "asc":data_asc,     //升序
        "desc":data_desc,       //降序
        "startDate":startDateParam.replace(/\//g,'-'),
        "endDate":endDateParam.replace(/\//g,'-')
      }
      expJson(api.entryStatisticsExportByDept,param).then(res =>{
          downloadExportedData(res.data, "关键条目缺陷占比.xls")
      })
  })
});